/*
  TITERM.CPP - Terminal Program for use with linkport.92p

  Uses code (a lot of it :-) from ti.c by dan@betterthan.northstar.k12.ak.us
  originally, modified (presumably) by davidell@ticalc.org.

  Modified/Written for DJGPP C by Bryan Rittmeyer (bryanr@flash.net).
  Highly optimized by Tim Gerla (timg@means.net).

  Ported to Win32 by Bryan Rittmeyer (bryanr@flash.net).

  0 - Both Red and White low - FREEZES CALC
  1 - Red line high
  2 - White line high
  3 - Both lines high (not used, normally)
*/

// Includes
#include <stdio.h>
#include <conio.h>

// You may need to tweak TIMAXTIME
#define TIMAXTIME 10000
#define lpt_base 0x378 // LPT1 -- 0x378, LPT2 -- 0x278, etc..
#define lpt_out lpt_base
#define lpt_in	(lpt_base+1)

int init_ti(void);
int get_ti(void);
int put_ti(unsigned char data);

// Main loop, provide simple character translation
main() {
  int ret,stop=0;
  char key;

  printf("Welcome to TI-92 Term. Hit ESC to quit.\n\n");
  fflush(stdout);
  init_ti();

  while( stop != 1 )
  {
    if ( kbhit() != 0 ) {
      key = getch();
      if ( key == 27 ) {
        stop=1;
        continue;
      }
	  if ( key == 8 ) {
		  put_ti(key);
		  put_ti(32);
		  put_ti(key);
	  }
	  else if ( key == 13 ) {
		  put_ti(key);
		  put_ti(10);
	  }
	  else
		  put_ti(key);
      if ( key == 13 )
         printf("\n");
	  else if ( key == 8 )
		  printf("%c %c",key,key);
	  else
		  printf("%c",key);
      fflush(stdout);
      continue;
    }
  
    ret=get_ti();
    if ( ret == -1 ) continue;
    if ( ret == 13 ) {
       printf("\n");
       fflush(stdout);
       continue;
       }
    printf("%c",ret);
    fflush(stdout);
  }

  fflush(stdin);
  return 0;
}

// Initialize Link port
int init_ti(void) {
  _outp(lpt_out,3);
  return 0;
}

// Send a byte out to the TI
int put_ti(unsigned char data) {
  int bit,titime=0;
	
  for (bit=0; bit<8; bit++) {
    _inp(lpt_in);
    _inp(lpt_in);
    _inp(lpt_in);
    if (data&1) {
//      getkey();
//      printf("Bit %d is a 1\n",bit);
//      fflush(stdout);
      _outp(lpt_out,2);
      while (_inp(lpt_in)&0x10) if(titime++>TIMAXTIME) return -1;
      _outp(lpt_out,3);
      while ((_inp(lpt_in)&0x10)==0x00) if(titime++>TIMAXTIME) return -1;
    } else {
//      getkey();
//      printf("Bit %d is a 0\n",bit);
//      fflush(stdout);
      _outp(lpt_out,1);
      while (_inp(lpt_in)&0x20) if(titime++>TIMAXTIME) return -1;
      _outp(lpt_out,3);
      while ((_inp(lpt_in)&0x20)==0x00) if(titime++>TIMAXTIME) return -1;
    }
    data>>=1;
  }
  return 0;
}

// Receive a byte from the TI
int get_ti(void) {
  int bit,titime=0;
  unsigned char data=0, v;
  
  for (bit=0; bit<8; bit++) {
    while ((v=_inp(lpt_in)&0x30) == 0x30) if(titime++>TIMAXTIME) return -1;
    if (v==0x10) {
      data=(data>>1)|0x80;
      _outp(lpt_out,1);
      while ((_inp(lpt_in)&0x20)==0x00) if(titime++>TIMAXTIME) return -1;
      _outp(lpt_out,3);
    } else {
      data=data>>1;
      _outp(lpt_out,2);
      while ((_inp(lpt_in)&0x10)==0x00) if(titime++>TIMAXTIME) return -1;
      _outp(lpt_out,3);
    }
    _inp(lpt_in);
    _inp(lpt_in);
    _inp(lpt_in);
  }
  return data;
}
